﻿namespace DiskAccessLibrary.Mod.Utility
{
    public class BlockEntryAllocateFlagIndexer
    {
        private const ulong FlagAllocated = 1UL << 63;

        private readonly ulong[] _entries;

        public BlockEntryAllocateFlagIndexer(ulong[] entries)
        {
            _entries = entries;
        }

        public bool this[int index]
        {
            get => 0 != (_entries[index] & FlagAllocated);

            set
            {
                if (value) _entries[index] |= FlagAllocated;
                else _entries[index] &= ~FlagAllocated;
            }
        }
    }
}