﻿namespace DiskAccessLibrary.Mod.Utility
{
    public class BlockEntryOffsetIndexer
    {
        private const ulong MaskOffset = (1UL << 63) - 1;
        private const ulong MaskClear = ~MaskOffset;
        private readonly ulong[] _entries;

        public BlockEntryOffsetIndexer(ulong[] entries)
        {
            _entries = entries;
        }

        public long this[int index]
        {
            get => (long)(_entries[index] & MaskOffset);
            set => _entries[index] = (_entries[index] & MaskClear) | ((ulong)value & MaskOffset);
        }
    }
}